[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]
Re: FYI, minor regression in coreutils-8.13: ls -lL vs. ACLs
From: |
Jim Meyering |
Subject: |
Re: FYI, minor regression in coreutils-8.13: ls -lL vs. ACLs |
Date: |
Wed, 05 Oct 2011 19:27:43 +0200 |
Jim Meyering wrote:
> FYI, coreutils-8.13 introduced a regression.
> With 8.12 and earlier, applying ls -lL to a symlink to an ACL'd file
> would do this:
>
> $ touch k; setfacl -m user:${USER}:r k; ln -s k s; env ls -lL s
> -rw-r-----+ 1 meyering meyering 0 Oct 3 13:16 s
>
> Note the "+".
> With 8.13, you get a "." (w/SELinux) or nothing (w/o SELinux)
> in place of the "+" indicator:
>
> $ env ls -lL s
> -rw-r-----. 1 meyering meyering 0 Oct 3 13:16 s
>
> For details, see this discussion:
>
> http://thread.gmane.org/gmane.comp.lib.gnulib.bugs/28538
Now that the offending file in gnulib is fixed,
here's the gnulib/test/NEWS change for coreutils:
>From d3d8938fd7bc8eeb6bc32d30704690cefa7955bb Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 3 Oct 2011 13:49:47 +0200
Subject: [PATCH] tests: add a test to exercise today's ls-lL-vs-ACL bug
* tests/ls/slink-acl: New file.
* tests/Makefile.am (TESTS): Add it.
* tests/init.cfg (require_setfacl_): New function.
* gnulib: Update to latest, for file-has-acl changes.
* NEWS (Bug fixes): Mention it.
See http://thread.gmane.org/gmane.comp.lib.gnulib.bugs/28538. This
":>k; setfacl -m m::r k; ln -s k s; ls -Log s" should print e.g.,
-rw-r-----+ 1 0 Oct 5 19:22 s
With the ls from coreutils-8.13, it would print this (with "." or
nothing in place of the "+"):
-rw-r-----. 1 0 Oct 5 19:22 s
---
NEWS | 3 +++
gnulib | 2 +-
tests/Makefile.am | 1 +
tests/init.cfg | 6 ++++++
tests/ls/slink-acl | 33 +++++++++++++++++++++++++++++++++
5 files changed, 44 insertions(+), 1 deletions(-)
create mode 100755 tests/ls/slink-acl
diff --git a/NEWS b/NEWS
index f50e61a..2934140 100644
--- a/NEWS
+++ b/NEWS
@@ -10,6 +10,9 @@ GNU coreutils NEWS -*-
outline -*-
dangling symlinks when an 'ln=target' entry is in $LS_COLORS.
[bug introduced in fileutils-4.0]
+ ls -lL symlink once again properly prints "+" when the referent has an ACL.
+ [bug introduced in coreutils-8.13]
+
** Improvements
md5sum --check now supports the -r format from the corresponding BSD tool.
diff --git a/gnulib b/gnulib
index 244794a..d813b68 160000
--- a/gnulib
+++ b/gnulib
@@ -1 +1 @@
-Subproject commit 244794a7887f13d9cdb91fed96932cc479905b96
+Subproject commit d813b688732c3a0da947f91cbb19cb78a627209e
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 2cf409a..9c9a1b8 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -431,6 +431,7 @@ TESTS = \
ls/readdir-mountpoint-inode \
ls/recursive \
ls/rt-1 \
+ ls/slink-acl \
ls/stat-dtype \
ls/stat-failed \
ls/stat-free-color \
diff --git a/tests/init.cfg b/tests/init.cfg
index f6eb651..04abe4f 100644
--- a/tests/init.cfg
+++ b/tests/init.cfg
@@ -130,6 +130,12 @@ require_strace_()
skip_ 'strace -qe "'"$1"'" does not work'
}
+require_setfacl_()
+{
+ setfacl -m user::rwx . \
+ || skip_ "setfacl does not work on the current file system"
+}
+
# Require a controlling input `terminal'.
require_controlling_input_terminal_()
{
diff --git a/tests/ls/slink-acl b/tests/ls/slink-acl
new file mode 100755
index 0000000..5cbb27a
--- /dev/null
+++ b/tests/ls/slink-acl
@@ -0,0 +1,33 @@
+#!/bin/sh
+# verify that ls -lL works when applied to a symlink to an ACL'd file
+
+# Copyright (C) 2011 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ ls
+
+require_setacl_
+
+touch k || framework_failure_
+setfacl -m m::r k || framework_failure_
+ln -s k s || framework_failure_
+
+set _ $(ls -Log s); shift; link=$1
+set _ $(ls -og k); shift; reg=$1
+
+test "$link" = "$reg" || fail=1
+
+Exit $fail
--
1.7.7.rc0.362.g5a14